unit FEKlavaro;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Registry, ShellAPI, Graphics,
  Esperanto;

const
    WM_SysTray=WM_User+1;
type

  TfrmEKlav = class(TForm)
    SpeedButton1: TSpeedButton;
    BevelKlavaro: TBevel;
    Panel1: TPanel;
    Panel2: TPanel;
    LabelKlavoj: TeoLabel;
    LabelKlavaro: TeoLabel;
    Label1: TeoLabel;
    Label2: TeoLabel;
    CheckBoxAuto: TeoCheckBox;
    CheckBoxVidebla: TeoCheckBox;
    CheckBoxStartMin: TeoCheckBox;
    CheckBoxAutoStart: TeoCheckBox;
    CheckBox: TeoCheckBox;
    RadioRekta: TeoRadioButton;
    RadioSenpasha: TeoRadioButton;
    Edit1: TEdit;
    Edit2: TEdit;
    PanelVarmaKlavo: TPanel;
    LabelVarmaKlavo: TeoLabel;
    EditVarmaKlavo: TEdit;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBoxClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure CheckBoxAutoClick(Sender: TObject);
    procedure CheckBoxAutoStartClick(Sender: TObject);
    procedure RadioRektaClick(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure Edit2Enter(Sender: TObject);
    procedure LabelVarmaKlavoClick(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure MouseEnter(Sender: TObject);
    procedure MouseLeave(Sender: TObject);
    procedure EditVarmaKlavoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditVarmaKlavoKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditVarmaKlavoKeyPress(Sender: TObject; var Key: Char);
    procedure EditVarmaKlavoEnter(Sender: TObject);
    procedure EditVarmaKlavoExit(Sender: TObject);
    procedure Label1Click(Sender: TObject);
  private
    FAppMutex: THandle;
    FAppMessage: Cardinal;
    FIconData: TNotifyIconData;
    FAtom: TAtom;
    procedure HotKey (var Msg: Integer); message WM_HotKey;
    procedure SysTray (var Msg: TMessage); message WM_SysTray;
    function AppHook (var Msg: TMessage): Boolean;
    procedure AppHide (Sender: TObject);
    procedure Unique;
    procedure Commit;
  end;

  procedure SetHook;    stdcall; external 'EKLAV.DLL' index 1;
  procedure SetHookD;   stdcall; external 'EKLAV.DLL' index 2;
  procedure RemoveHook; stdcall; external 'EKLAV.DLL' index 4;
  function BroadcastSysMessage(Flags: DWORD; Recipients: PDWORD; uiMessage: UINT; wParam: WPARAM; lParam: LPARAM): Longint; stdcall;

var
  frmEKlav: TfrmEKlav;

implementation

{$R *.DFM}

var Ek,Morta,Auto,Videbla,StartMin: Boolean;
    MK_1,MK_2: Char;
    Down: Boolean;
    VInfo: TOSVersionInfo;
    ProgPath: String;

procedure GetSysInfo;
begin
  VInfo.dwOSVersionInfoSize:=sizeof(TOSVersionInfo);
  GetVersionExA(VInfo);
end;


type THotKey = record
        Mode: Integer;
        Key: Integer;
     end;

var HKey: THotKey=(Mode:MOD_CONTROL; Key:VK_Space);

function getHotKeyName (K: THotKey): String;
 var Buf: array [1..80] of char;
begin
    result:='';
    if (K.Mode and MOD_ALT)<>0 then
        result:=result+'Alt+';
    if (K.Mode and MOD_CONTROL)<>0 then
        result:=result+'Ctrl+';
    if (K.Mode and MOD_SHIFT)<>0 then
        result:=result+'Shift+';
    if (K.Key=VK_Control) or (K.Key=VK_Shift) or (K.Key=VK_Menu) then
        exit;
    GetKeyNameText((MapVirtualKey(K.Key, 0) shl 16),@Buf,SizeOf(buf));
    result:=result+Buf;
end; {getHotKeyName}

procedure SearchEKlav;
 var i,u,a: integer;
     Ini: TRegIniFile;
     Prev,Ekla,Ikla,Kla: THandle; {origina kaj Esperanta klavararangxoj}
     Locale: String;
     KbName: array [1..128] of char;
begin
    Ini:=TRegIniFile.Create('Software');
    Locale:=Ini.ReadString('EK', 'Locale', '');
    if Locale='' then
        Prev:=ActivateKeyboardLayout(HKL_NEXT,0)
    else
        Prev:=ActivateKeyboardLayout(LoadKeyboardLayout(PChar(Locale),0),0);
    Ekla:=0; IKla:=0; i:=0;
    repeat      {trovu esperantan klavaron}
        u:=VkKeyScanW(#$16d);       {unikoda 'ux'}
        if u=0 then                 {Vin95 ne subtenas unikodan VkKeyScan!}
            u:=VkKeyScan('');
        a:=VkKeyScanW(#$e1);
        if a=0 then
           a:=VkKeyScan(#$e1);
        GetKeyBoardLayoutName(@KbName);
        Kla:=ActivateKeyboardLayout(HKL_NEXT,0);
        if Chr(u)='U' then EKla:=Kla;
        {if StrPas(@kbName)='00020409' then
           IKla:=Kla;}
        if (a>$1FF) and (Chr(a)='A') and (Ikla=0) then
           Ikla:=Kla;
        Inc(i);
    until {(Kla=Prev) or} (i>20);
    ActivateKeyboardLayout(Prev,0);
    if EKla=0 then
    begin
        beep;
        MessageDlg('Esperanta klavararangho ne estas instalita!',
            mtError, [mbOk], 0);
    end;

    Ini.WriteInteger('EK', 'Ekla', Ekla);
    Ini.WriteInteger('EK', 'Ikla', Ikla);
    Ini.Free;
end; {SearchEKlav}

var Silentu: Boolean=False;
{Legu parametrojn el la registrejo}
procedure ReadIni;
 var Ini: TRegIniFile;
     MK1,MK2: Integer;
begin
    Ini:=TRegIniFile.Create('Software');
    MK1:=Ini.ReadInteger('EK', 'MK_1', 41);
    MK2:=Ini.ReadInteger('EK', 'MK_2', 43);
    Morta:=Ini.ReadBool('EK', 'Metodo', False);
    Auto:=Ini.ReadBool('EK', 'Auto', True);
    Videbla:=Ini.ReadBool('EK', 'Videbla', False);
    StartMin:=Ini.ReadBool('EK', 'StartMin', False);
    ProgPath:=Ini.ReadString('EK','Path',ParamStr(0));
    frmEKlav.CheckBoxAutoStart.Checked:=Ini.ReadBool('EK', 'AutoStart', False);
    HKey.Key:=Ini.ReadInteger('EK','HotKey',VK_Space);
    HKey.Mode:=Ini.ReadInteger('EK','HotKeyMode',MOD_CONTROL);

    MK_1:=Chr(MapVirtualKey(MapVirtualKey(MK1,1),2));
    MK_2:=Chr(MapVirtualKey(MapVirtualKey(MK2,1),2));
    frmEklav.Font.Charset:=Ini.ReadInteger('EK', 'FontCharset', BALTIC_CHARSET);
    UseUnicode:=Ini.ReadBool('EK', 'UseUnicode', True);
    frmEKlav.Edit1.Text:=MK_1;
    frmEKlav.Edit2.Text:=MK_2;
    frmEKlav.CheckBoxAuto.Checked:=Auto;
    frmEKlav.CheckBoxStartMin.Checked:=StartMin;
    frmEKlav.CheckBoxVidebla.Checked:=Videbla;
    Silentu:=True;
    frmEKlav.CheckBox.Checked:=Ini.ReadBool('EK', 'Aktiva', False);
    Silentu:=False;
    Ini.Free;
end; {ReadIni}

{Savu parametrojn en la registrejo}
procedure SaveIni;
 var Ini: TRegIniFile;
begin
    with frmEKlav do
    begin
      if Edit1.Text='' then MK_1:=Chr(0)
      else MK_1:=Edit1.Text[1];
      if Edit2.Text='' then MK_2:=Chr(0)
      else MK_2:=Edit2.Text[1];
      Auto:=CheckBoxAuto.Checked;
      StartMin:=CheckBoxStartMin.Checked;
      Videbla:=CheckBoxVidebla.Checked;
    end;

    Ini:=TRegIniFile.Create('Software');
    Ini.WriteBool('EK', 'Metodo', Morta);
    Ini.WriteBool('EK', 'Auto', Auto);
    Ini.WriteBool('EK', 'Videbla', Videbla);
    Ini.WriteBool('EK', 'StartMin', StartMin);
    Ini.WriteInteger('EK', 'MK_1', MapVirtualKey(VkKeyScan(MK_1) and 255,0));
    Ini.WriteInteger('EK', 'MK_2', MapVirtualKey(VkKeyScan(MK_2) and 255,0));
    Ini.WriteBool('EK', 'Aktiva', frmEKlav.CheckBox.Checked);
    Ini.WriteBool('EK','NT',VInfo.dwPlatformId=VER_PLATFORM_WIN32_NT);
    Ini.WriteInteger('EK','HotKey',HKey.Key);
    Ini.WriteInteger('EK','HotKeyMode',HKey.Mode);
    Ini.Free;
end; {SaveIni}

function BroadcastSysMessage; external user32 name 'BroadcastSystemMessage';

procedure TfrmEKlav.Unique;
 var AppMutex: THandle;
     Recipients: DWORD;
begin
    FAppMessage := RegisterWindowMessage('Ek!');
    AppMutex := OpenMutex(MUTEX_ALL_ACCESS, False, 'Ek!');
    if AppMutex = 0 then
    begin
      FAppMutex := CreateMutex(nil, False, 'Ek!');
      Application.HookMainWindow(AppHook);
    end else
    begin
      CloseHandle(AppMutex);
      Recipients := BSM_APPLICATIONS;
      BroadcastSysMessage(BSF_IGNORECURRENTTASK or BSF_POSTMESSAGE, @Recipients, FAppMessage, 0, 0);
      Halt;
    end;
end; {TfrmEKlav.Unique}

{Kreu cxefan fenestron}
procedure TfrmEKlav.FormCreate (Sender: TObject);
begin
    Unique;             // nur unu ekzemplero de la programo rajtas funkcii
    with FIconData do   // pravalorizo de taskopleta piktogramo
    begin
      cbSize := SizeOf(FIconData);
      Wnd:=self.Handle;                     // fenestro ricevonta eventojn
      uID := $DEDB;                         // application-defined ID for icon (can be any UINT value)
      uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
      hIcon := Application.Icon.Handle;
      uCallbackMessage := WM_USER+1;
      StrCopy(szTip, PChar(Caption));       // szTip is the ToolTip text (64 byte array including NULL)
    end;
    Shell_NotifyIcon(NIM_Add, @FIconData);  // kreu la piktogramon

    GetSysInfo;
    Top:=Screen.Height-Height-40;
    Left:=(Screen.Width-Width-5);
    SearchEKlav;
    ReadIni;
    //RadioGroup.ItemIndex:=Ord(Morta);
    if Morta then RadioSenpasha.Checked:=True
    else RadioRekta.Checked:=True;
    Application.OnMinimize:=AppHide;        // kaptu minimumigon
    FAtom:=GlobalAddAtom('Ek!');
    EditVarmaKlavo.Text:=getHotKeyName(HKey);
    RegisterHotKey(self.Handle,FAtom,HKey.Mode,HKey.Key);
    Down:=False;
    if StartMin then
        Application.ShowMainForm:=False;
end; {TfrmEKlav.FormCreate}

function TfrmEklav.AppHook (var Msg: TMessage): Boolean;
begin
  Result:=False;
  try
    if Msg.Msg=FAppMessage then
    begin
      frmEKlav.Show;
      Application.Restore;
      Application.BringToFront;
      Result:=True;
    end;
  except
    Application.HandleException(Self);
  end;
end; {TfrmEklav.AppHook}

{Se uzulo minimumigas - kasxigxu}
procedure TfrmEKlav.AppHide (Sender: TObject);
begin
    Hide;
end; {TfrmEKlav.AppHide}

procedure TfrmEKlav.FormDestroy (Sender: TObject);
begin                   // forigu la piktogramon
    Shell_NotifyIcon(NIM_DELETE, @FIconData);
    RemoveHook;         // forigu kapton de klavaraj eventoj

    Application.UnhookMainWindow(AppHook);
    CloseHandle(FAppMutex);
    GlobalDeleteAtom(FAtom);
end; {TfrmEKlav.FormDestroy}

{Prilaboro de eventoj de la taskopleto}
procedure TfrmEKlav.SysTray (var Msg: TMessage);
begin
    if Msg.Msg<>WM_SysTray then exit;
    case Msg.LParam of
     WM_RBUTTONDBLCLK,
     WM_RBUTTONDown:
        begin
            if frmEKlav.Visible then
                Application.Minimize
            else begin
                frmEKlav.Show;
                Application.Restore;
                Application.BringToFront;
            end;
        end;
     WM_LBUTTONDBLCLK,
     WM_LBUTTONDown:
        begin
            Ek:=not Ek;
            CheckBox.Checked:=Ek;
        end;
    end;
end; {TfrmEKlav.SysTray}

{Kaptu Ctrl+Space}
procedure TfrmEKlav.HotKey (var Msg: Integer);
begin
    Ek:=not Ek;
    CheckBox.Checked:=Ek;
end; {TfrmEKlav.HotKey}

procedure TfrmEKlav.FormClose (Sender: TObject; var Action: TCloseAction);
begin
    UnRegisterHotKey(self.Handle,FAtom);
    SaveIni;
end; {TfrmEKlav.FormClose}

{Aktivigu/malaktivigu}
procedure TfrmEKlav.CheckBoxClick(Sender: TObject);
begin
    if not Silentu then beep;
    try
      if CheckBox.Checked then
        Application.Icon.Handle := LoadIcon(MainInstance, 'ICON_2')
      else begin
        Application.Icon.Handle := LoadIcon(MainInstance, 'ICON_1')
      end;
    except
    end;

    FIconData.hIcon := Application.Icon.Handle;
    Shell_NotifyIcon(NIM_MODIFY, @FIconData);

    SaveIni;
    if not CheckBox.Checked then
        RemoveHook
    else if not Morta then
        SetHook
    else
        SetHookD;
end; {TfrmEKlav.CheckBoxClick}

procedure Delay (MSecs: Longint);
var
  FirstTickCount, Now: Longint;
begin
  FirstTickCount := GetTickCount;
  repeat
    Application.ProcessMessages;  {allowing access to other controls, etc.}
    Now := GetTickCount;
  until (Now - FirstTickCount >= MSecs) or (Now < FirstTickCount);
end;

procedure TfrmEKlav.Commit;
begin
    if not Active then exit;
    SaveIni;
    if not CheckBox.Checked then exit;
    RemoveHook;
    Delay(200);  {mi ne scias kial, sed sen tio ne funkcias}
    if not Morta then SetHook
    else SetHookD;
end; {TfrmEKlav.Commit}

procedure TfrmEKlav.SpeedButton1Click (Sender: TObject);
 var H: String;
begin
    H:='start "'+ExtractFilePath(ParamStr(0))+'Helpo\index.htm"';
    WinExec(PChar(H),SW_HIDE);
    //frmHelp.ShowModal;
end; {TfrmEKlav.SpeedButton1Click}

procedure TfrmEKlav.FormKeyDown (Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if Key=VK_F1 then SpeedButton1Click(Sender);
end; {TfrmEKlav.FormKeyDown}

procedure TfrmEKlav.Edit1Exit (Sender: TObject);
begin
    Panel1.BevelOuter:=bvNone;
end; {Edit1Change}

procedure TfrmEKlav.Edit2Exit (Sender: TObject);
begin
    Panel2.BevelOuter:=bvNone;
end; {Edit1Change}

procedure TfrmEKlav.EditKeyUp (Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (Edit1.Text<> MK_1) or (Edit2.Text<>MK_2) then
        Commit;
end; {TfrmEKlav.EditKeyUp}

procedure TfrmEKlav.Edit1KeyPress (Sender: TObject; var Key: Char);
begin
    if (Key<>Chr(VK_Return)) and (Key<>Chr(VK_Back)) and (Key<>' ') then
        Edit1.Text:=UpperCase(Key)
    else if Key=' ' then
        Key:=Chr(0);
end; {TfrmEKlav.Edit1KeyPress}

procedure TfrmEKlav.Edit2KeyPress (Sender: TObject; var Key: Char);
begin
    if (Key<>Chr(VK_Return)) and (Key<>Chr(VK_Back)) and (Key<>' ') then
        Edit2.Text:=UpperCase(Key)
    else if Key=' ' then
        Key:=Chr(0);
end; {TfrmEKlav.Edit2KeyPress}

procedure TfrmEKlav.CheckBoxAutoClick(Sender: TObject);
begin
    Commit;
end;

procedure TfrmEKlav.CheckBoxAutoStartClick(Sender: TObject);
 var Ini: TRegistry;
begin
    Ini:=TRegistry.Create;
    if CheckBoxAutoStart.Checked then
    begin
        Ini.RootKey:=HKEY_CURRENT_USER;
        Ini.OpenKey('\Software\Ek',True);
        Ini.WriteString('AutoStart','1');
        Ini.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run',True);
        Ini.WriteString('Ek','"'+ProgPath+'"');
    end
    else begin
        Ini.RootKey:=HKEY_CURRENT_USER;
        Ini.OpenKey('\Software\Ek',True);
        Ini.WriteString('AutoStart','0');
        Ini.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run',True);
        Ini.DeleteValue('Ek');
    end;
    Ini.Free;
end;

procedure TfrmEKlav.RadioRektaClick(Sender: TObject);
begin
    if RadioRekta.Checked then Morta:=False
    else if RadioSenpasha.checked then Morta:=True;
    //Morta:=(RadioGroup.ItemIndex=1);
    Commit;
end;

procedure TfrmEKlav.Edit1Enter(Sender: TObject);
begin
      Panel1.BevelOuter:=bvLowered;
      ActiveControl:=Edit1;
end;

procedure TfrmEKlav.Edit2Enter(Sender: TObject);
begin
      Panel2.BevelOuter:=bvLowered;
      ActiveControl:=Edit2;
end;

procedure TfrmEKlav.Label1Click(Sender: TObject);
begin
      ActiveControl:=Edit1;
end;

procedure TfrmEKlav.Label2Click(Sender: TObject);
begin
      ActiveControl:=Edit2;
end;

type TmyControl = class (TControl)
      public
        property Font;
     end;

procedure TfrmEKlav.MouseEnter(Sender: TObject);
begin
//    TmyControl(Sender).Font.Color:=clPurple;
end;

procedure TfrmEKlav.MouseLeave(Sender: TObject);
begin
//    TmyControl(Sender).Font.Color:=clBlack;
end;

procedure TfrmEKlav.EditVarmaKlavoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
 var HKey0: THotKey;
begin
    HKey0.Mode:=0; HKey0.Key:=Key;
    if ssShift in Shift then Inc(HKey0.Mode,MOD_SHIFT);
    if ssAlt   in Shift then Inc(HKey0.Mode,MOD_ALT);
    if ssCtrl  in Shift then Inc(HKey0.Mode,MOD_CONTROL);
    with EditVarmaKlavo do
    begin
        Text:=GetHotKeyName(HKey0);
        if (Key<>VK_Control) and (Key<>VK_Menu) and (Key<>VK_Shift)
            and (Key<>VK_CAPITAL) and (HKey0.Mode>0)then
            HKey:=HKey0;
    end;
    Key:=0;
end; {TfrmEKlav.EditVarmaKlavoKeyDown}

procedure TfrmEKlav.EditVarmaKlavoKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    EditVarmaKlavo.Text:=GetHotKeyName(HKey);
    Key:=0;
end; {TfrmEKlav.EditVarmaKlavoKeyUp}

procedure TfrmEKlav.EditVarmaKlavoKeyPress(Sender: TObject; var Key: Char);
begin
    Key:=Chr(0);
end; {TfrmEKlav.EditVarmaKlavoKeyPress}

procedure TfrmEKlav.EditVarmaKlavoEnter(Sender: TObject);
begin
    UnRegisterHotKey(self.Handle,FAtom);
    PanelVarmaKlavo.BevelOuter:=bvLowered;
end; {TfrmEKlav.EditVarmaKlavoEnter}

procedure TfrmEKlav.EditVarmaKlavoExit(Sender: TObject);
begin
    RegisterHotKey(self.Handle,FAtom,HKey.Mode,HKey.Key);
    PanelVarmaKlavo.BevelOuter:=bvNone;
end; {TfrmEKlav.EditVarmaKlavoExit}

procedure TfrmEKlav.LabelVarmaKlavoClick(Sender: TObject);
begin
    ActiveControl:=EditVarmaKlavo;
end;


end.
